/*
 * File:   UART.h
 * Author: Ran
 *
 * Created on June 25, 2013, 7:36 PM
 */

void uart(void)
{
        TRISCbits.TRISC7=1; //Make UART RX pin input
        TRISCbits.TRISC6=0; //Make UART TX pin output
        SPBRGH  = 0    ;     //9600bps 16MHz Osc
        SPBRG   = 25;

        RCSTAbits.CREN=1;   //1 = Enables receiver
        RCSTAbits.SPEN=1;   //1 = Serial port enabled (configures RX/DT and TX/CK pins as serial port pins)
        BAUDCONbits.BRG16=1;//1 = 16-bit Baud Rate Generator ? SPBRGH and SPBRG
        BAUDCONbits.CKTXP = 1;

        TXSTAbits.SYNC=0;  //0 = Asynchronous mode
        TXSTAbits.BRGH=1;  //1 = High speed
        TXSTAbits.SENDB = 0;
        BAUDCONbits.DTRXP =1;
        PIE1bits.TXIE = 1;
}

unsigned char receive(void)
{
    unsigned char data;
    if(RCSTAbits.FERR==1 && RCSTAbits.OERR==1 )
    {
        while(PIR1bits.RCIF == 1)
        {
          RCSTAbits.CREN =0;    //Overrun error (can be cleared by clearing bit CREN)
          data = RCREG;
          RCSTAbits.CREN =1;
        }
    }
    else
    {       
       while(PIR1bits.RCIF == 1)
        {
            RCSTAbits.CREN =0;    //Overrun error (can be cleared by clearing bit CREN)
            data = RCREG;
            RCSTAbits.CREN =1;
        }
    }
    return data;
}

void sendbyte(unsigned char data)
{
        TXREG = data;
        TXSTAbits.TXEN=0;
            while(TXSTAbits.TRMT == 0)
            {
                    TXSTAbits.TXEN=1;    // enable transmission
                    while(TXSTAbits.TRMT == 0 ) // wait here till transmit complete
                    { NOP(); }
            }
        TXSTAbits.TXEN=0;
}


